#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

struct rw_lock {
    int     reader_lock;
    int     writer_lock;
    int     readers;
};

void lock(int *x) {
    while (__sync_val_compare_and_swap(x, 0, 1))
        ;
}

void unlock(int *x) {
    *x = 0;
}

void lock_rd(struct rw_lock *rwl) {
    lock(&rwl->reader_lock);
    ++rwl->readers;
    if (rwl->readers == 1)
        lock(&rwl->writer_lock);
    unlock(&rwl->reader_lock);
}

void unlock_rd(struct rw_lock *rwl) {
    lock(&rwl->reader_lock);
    --rwl->readers;
    if (rwl->readers == 0)
        unlock(&rwl->writer_lock);
    unlock(&rwl->reader_lock);
}

void lock_wr(struct rw_lock *rwl) {
    lock(&rwl->writer_lock);
}

void unlock_wr(struct rw_lock *rwl) {
    unlock(&rwl->writer_lock);
}


